package org.nl.acs.device.service;

import org.nl.acs.device.domain.DeviceAssigned;
import org.nl.acs.device.service.dto.DeviceAssignedDto;
import org.nl.acs.device.service.dto.DeviceAssignedQueryParam;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.common.base.PageInfo;
import org.springframework.data.domain.Pageable;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface DeviceAssignedService extends CommonService<DeviceAssigned>  {

    static final String CACHE_KEY = "deviceAssigned";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<DeviceAssignedDto>
    */
    PageInfo<DeviceAssignedDto> queryAll(DeviceAssignedQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<DeviceAssignedDto>
    */
    List<DeviceAssignedDto> queryAll(DeviceAssignedQueryParam query);

    DeviceAssigned getById(String id);
    DeviceAssignedDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(DeviceAssignedDto resources);
    int updateById(DeviceAssignedDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<DeviceAssignedDto> all, HttpServletResponse response) throws IOException;

    /**
     * 查询数据分页
     *
     * @param whereJson 条件
     * @param page      分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(Map whereJson, Pageable page);

    /**
     * 查询所有数据不分页
     *
     * @param whereJson 条件参数
     * @return List<DeviceAssignedDto>
     */
    List<DeviceAssignedDto> queryAll(Map whereJson);

    /**
     * 根据ID查询
     *
     * @param assigned_id ID
     * @return DeviceAssigned
     */
//    DeviceAssignedDto findById(String assigned_id);

    /**
     * 根据编码查询
     *
     * @param code code
     * @return DeviceAssigned
     */
//    DeviceAssignedDto findByCode(String code);


    /**
     * 创建
     *
     * @param whereJson /
     */
    void create(Map whereJson);

    /**
     * 编辑
     *
     * @param dto /
     */
    void update(Map whereJson);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(String[] ids);

    /**
     * 导出数据
     *
     * @param dtos     待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<DeviceAssignedDto> dtos, HttpServletResponse response) throws IOException;

    List<DeviceAssignedDto> queryAssignedBydevice(String device_code, String task_nextdeice_code);
}
